<?php
/**
* @version		$Id: helper.php v 1.1 2010/04/19 $
* @author		Madebyplay
* @package		CU3ER
* @copyright		(C) 2010-2013 Madebyplay (www.madebyplay.com)
* @license		http://www.gnu.org/copyleft/gpl.html GNU/GPL
* Notice:		The Cu3er module uses swfobject 
*			(http://code.google.com/p/swfobject/) to embed
*			flash movies into Joomla module positions.
*/

// no direct access
defined('_JEXEC') or die;

class modCu3erHelper {

    public static $alt_content;

	public static function addJsCode($id, $num) {

		$document = &JFactory::getDocument();
		jimport('joomla.filesystem.file');
		jimport('joomla.utilities.simplexml');

		$XML_encoded = JFile::read(JPATH_SITE.DS.'components'.DS.'com_cu3er'.DS.'slideshows'.DS.$id.DS.'CU3ER-generated.xml');

		$xml = JFactory::getXMLParser('Simple');
		$xml->loadString($XML_encoded);

		$xml_doc = &$xml->document;
		
		if (	$xml_doc->getElementByPath('settings/published') && 
			$xml_doc->getElementByPath('settings/published')->data() == 1) {

			self::$alt_content = ($xml_doc->getElementByPath('settings/content'))?$xml_doc->getElementByPath('settings/content')->data():'';

			// setting slideshow parameters from parsed XML nodes
			$backgroundType = ($xml_doc->getElementByPath('settings/background/color')->attributes('transparent'))?'transparent':false;		
			$background = $xml_doc->getElementByPath('settings/background/color')->data();
			$folder_images = $xml_doc->getElementByPath('settings/folder_images')->data();
			$folder_fonts = $xml_doc->getElementByPath('settings/folder_fonts')->data();
			$width = $xml_doc->getElementByPath('project_settings/width')->data();
			$height = $xml_doc->getElementByPath('project_settings/height')->data();
			$force_js = ($xml_doc->getElementByPath('settings/force_js'))?$xml_doc->getElementByPath('settings/force_js')->data():'false';

			if ($force_js != 'false') {
				Cu3erFile::addJsFile('jquery.cu3er.player.js');
				Cu3erFile::addCSSFile('CU3ER.css');
				Cu3erFile::addCSSFile('CU3ERieFix.css', 'IE');
			}

			$CU3ER_root = JURI::root().'components'.DS.'com_cu3er'.DS;
			preg_replace('/http\:\/\/(.*?)\//', '/', $CU3ER_root);		

			$CU3ER_root = JURI::root().'components'.DS.'com_cu3er';
			preg_replace('/http\:\/\/(.*?)\//', '/', $CU3ER_root);		

			$wmode = ($backgroundType == 'transparent') ? "transparent" : "color: ".str_replace('0x', '#', $background);
			$uenc_XML = urlencode($XML_encoded);
			$js_str = <<<EOD
				
				jQuery(document).ready(function($) {					
					$('#CU3ERmod{$num}').cu3er({
						vars: {
							xml_location: '{$CU3ER_root}/slideshows/{$id}/CU3ER-config.xml',
							xml_encoded: '{$uenc_XML}',
							swf_location: '{$CU3ER_root}/flash/CU3ER.swf',
							width: '{$width}',
							height: '{$height}',
							force_javascript: {$force_js},
							folder_images: '{$folder_images}',
							folder_fonts: '{$folder_fonts}',
						},
						params: {
							wmode: '{$wmode}',
							allowScriptAccess: 'always',
						},
						attributes: {
							name:'CU3ERmod{$num}',
							id:'CU3ERmod{$num}',
						}
					});
				});
EOD;

			$document->addScriptDeclaration($js_str);
		} else {
			return false;
		}
	}
}
